"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var provider_1 = require("./provider");
var firebase_1 = __importDefault(require("firebase"));
var react_social_login_buttons_1 = require("react-social-login-buttons");
var react_2 = __importDefault(require("react"));
exports.GenericButton = function (_a) {
    var text = _a.text, _b = _a.provider, provider = _b === void 0 ? null : _b, Button = _a.Button;
    var _c = provider_1.useAuthData(), user = _c.user, loading = _c.loading;
    if (loading) {
        return (react_2.default.createElement(Button, { style: {
                background: '#eee',
                color: 'black',
                cursor: 'default',
                boxShadow: 'none',
            }, activeStyle: {}, preventActiveStyles: true, text: 'loading' }));
    }
    return (react_2.default.createElement(Button, { onClick: function () { return firebase_1.default.auth().signInWithRedirect(provider); }, text: text }));
};
function useProvider(_a) {
    var Provider = _a.Provider, scopes = _a.scopes;
    var provider = react_1.useMemo(function () {
        var p = new Provider();
        if (scopes && scopes.length) {
            scopes.forEach(function (scope) {
                var _a;
                (_a = p === null || p === void 0 ? void 0 : p.addScope) === null || _a === void 0 ? void 0 : _a.call(p, scope);
            });
        }
        return p;
    }, []);
    return provider;
}
exports.GoogleButton = function (_a) {
    var scopes = _a.scopes, props = __rest(_a, ["scopes"]);
    var provider = useProvider({
        Provider: firebase_1.default.auth.GoogleAuthProvider,
        scopes: scopes,
    });
    return (react_2.default.createElement(exports.GenericButton, __assign({ text: 'Sign In With Google', Button: react_social_login_buttons_1.GoogleLoginButton, provider: provider }, props)));
};
exports.GithubButton = function (_a) {
    var scopes = _a.scopes, props = __rest(_a, ["scopes"]);
    var provider = useProvider({
        Provider: firebase_1.default.auth.GithubAuthProvider,
        scopes: scopes,
    });
    return (react_2.default.createElement(exports.GenericButton, __assign({ text: 'Sign In With Github', Button: react_social_login_buttons_1.GithubLoginButton, provider: provider }, props)));
};
exports.FacebookButton = function (_a) {
    var scopes = _a.scopes, props = __rest(_a, ["scopes"]);
    var provider = useProvider({
        Provider: firebase_1.default.auth.FacebookAuthProvider,
        scopes: scopes,
    });
    return (react_2.default.createElement(exports.GenericButton, __assign({ text: 'Sign In With Facebook', Button: react_social_login_buttons_1.FacebookLoginButton, provider: provider }, props)));
};
exports.TwitterButton = function (_a) {
    var scopes = _a.scopes, props = __rest(_a, ["scopes"]);
    var provider = useProvider({
        Provider: firebase_1.default.auth.TwitterAuthProvider,
        scopes: scopes,
    });
    return (react_2.default.createElement(exports.GenericButton, __assign({ text: 'Sign In With Twitter', Button: react_social_login_buttons_1.TwitterLoginButton, provider: provider }, props)));
};
